/*
 * HnStatisticsSt.h
 * Copyright (C) 1999 Norio Katayama
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 *
 * 08/01/1999 Norio KATAYAMA
 * $Id: HnStatisticsSt.h,v 1.2 2000/06/10 11:13:11 katayama Exp $
 */

#ifndef _HnStatisticsSt_h
#define _HnStatisticsSt_h

/*
 * Structure
 */

typedef struct {
    double sum;
    double sum2;
    double min;
    double max;
    int count;
} HnStatisticsSt;

/*
 * Functions
 */

#ifdef __cplusplus
extern "C" {
#endif

HnStatisticsSt *HnStatisticsSt_allocate(void);
void HnStatisticsSt_free(HnStatisticsSt *sp);

void HnStatisticsSt_addSample(HnStatisticsSt *sp, double sample);
void HnStatisticsSt_print(const HnStatisticsSt *sp);

double HnStatisticsSt_getSum(const HnStatisticsSt *sp);
double HnStatisticsSt_getAvg(const HnStatisticsSt *sp);
double HnStatisticsSt_getVar(const HnStatisticsSt *sp);
double HnStatisticsSt_getStd(const HnStatisticsSt *sp);
double HnStatisticsSt_getMin(const HnStatisticsSt *sp);
double HnStatisticsSt_getMax(const HnStatisticsSt *sp);
int HnStatisticsSt_getNumSamples(const HnStatisticsSt *sp);

#ifdef __cplusplus
};
#endif

#define HnClass HnStatistics
#include "HnSRTree/HnClassArraySt.h"

#endif /* _HnStatisticsSt_h */
