/*
 * HnTimesSt.h
 * Copyright (C) 1999 Norio Katayama
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 *
 * 08/01/1999 Norio KATAYAMA
 * $Id: HnTimesSt.h,v 1.2 2000/06/10 11:13:14 katayama Exp $
 */

#ifndef _HnTimesSt_h
#define _HnTimesSt_h

#include <sys/time.h>

/*
 * Structure
 */

typedef struct {
    struct timeval rtime;
    struct timeval utime;
    struct timeval stime;
} HnTimesSt;

/*
 * Functions
 */

#ifdef __cplusplus
extern "C" {
#endif

HnTimesSt *HnTimesSt_allocate(void);
void HnTimesSt_free(HnTimesSt *tp);

double HnTimesSt_getRealTime(const HnTimesSt *tp);
double HnTimesSt_getUserTime(const HnTimesSt *tp);
double HnTimesSt_getSystemTime(const HnTimesSt *tp);
double HnTimesSt_getCPUTime(const HnTimesSt *tp);

void HnTimesSt_setCurrentTimes(HnTimesSt *tp);
void HnTimesSt_add(HnTimesSt *tp3,
		   const HnTimesSt *tp1, const HnTimesSt *tp2);
void HnTimesSt_subtract(HnTimesSt *tp3,
			const HnTimesSt *tp1, const HnTimesSt *tp2);
void HnTimesSt_print(const HnTimesSt *tp);

#ifdef __cplusplus
};
#endif

#define HnClass HnTimes
#include "HnSRTree/HnClassArraySt.h"

#define CLK_TCK  100     /*Add by Diego*/

#endif /* _HnTimesSt_h */
